/*
 * mytasks.c
 *
 * Created: 7/5/2011 23:45:23
 *  Author: MMM
 */ 
#include <avr/pgmspace.h>
#include "FreeRTOS.h"
#include "task.h"
#include "semphr.h"
#include "LED.h"
#include "button.h"
#include "lcd_lib.h"
#include "mytasks.h"
#include "freertosm128.h"
void vLEDFlashTask( void *pvParameters )
{
vLEDInit();
portTickType xLastWakeTime;
const portTickType xFrequency = 1000;
xLastWakeTime=xTaskGetTickCount();
	for( ;; )
	{
		vLEDToggle();
		vTaskDelayUntil(&xLastWakeTime,xFrequency);		
	}
	
}
void vButtonCheckTask( void *pvParameters )
{
portTickType xLastWakeTime;
const portTickType xFrequency = 20;
xLastWakeTime=xTaskGetTickCount();
//resets initial semaphore to 0
xSemaphoreTake(xButtonSemaphore, (portTickType)0);
vButtonInit();
	for (;;)
	{
	if (xButtonGetStatus()==pdTRUE)
		{
			xSemaphoreGive(xButtonSemaphore);
		}
	vTaskDelayUntil(&xLastWakeTime,xFrequency);	
	}
}
void vLCDUpdateTask( void *pvParameters )
{
static const uint8_t welcomeln1[] PROGMEM="FreeRTOS DEMO";
static const uint8_t buttonln1[] PROGMEM="BT:";
static const uint8_t tasksln1[] PROGMEM="TSKS:";
portTickType xLastWakeTime;
const portTickType xFrequency = 500;
xLastWakeTime=xTaskGetTickCount();
unsigned portBASE_TYPE uxTasks, rxchar;
LCDinit();
LCDclr();
LCDcursorOFF();
CopyStringtoLCD(welcomeln1, 0, 0);
CopyStringtoLCD(buttonln1, 0, 1);
CopyStringtoLCD(tasksln1, 7, 1);

	for (;;)
	{
		if (xUSART0GetChar(&rxchar)!=pdFALSE)
		{
		LCDGotoXY(14,0);
		LCDsendChar(rxchar);
		}

		uxTasks=uxTaskGetNumberOfTasks();
		LCDGotoXY(13,1);
		//works only up to 9 tasks
		LCDsendChar(uxTasks+48);
		if (xButtonSemaphore != NULL)
		{
			LCDGotoXY(3,1);
			//poll
			if (xSemaphoreTake(xButtonSemaphore, (portTickType)0)==pdTRUE)
			{
				LCDsendChar('1');
				//give back semaphore
				xSemaphoreGive(xButtonSemaphore);
			}
			else
			{
				LCDsendChar('0');
			}
		}

	vTaskDelayUntil(&xLastWakeTime,xFrequency);	
	}
}
void vUSART0TxTask( void *pvParameters )
{
static const uint8_t button[] PROGMEM="Button ON\r\n";
static const uint8_t rtos[] PROGMEM="Button OFF\r\n";
portTickType xLastWakeTime;
const portTickType xFrequency = 2000;
vUSART0Init(30);
xLastWakeTime=xTaskGetTickCount();
	for( ;; )
	{
if(xButtonSemaphore!=NULL)
{
	if (xSemaphoreTake(xButtonSemaphore, (portTickType)10)==pdTRUE)
	{
		xUSART0SendDataP(button);
		//don't give back semaphore as it is one way trigger
	}else{
		xUSART0SendDataP(rtos);
	}
}
		vTaskDelayUntil(&xLastWakeTime,xFrequency);		
	}
	
}
void vXMEMTestTask( void *pvParameters )
{
static const uint8_t xmemok[] PROGMEM="XMEM OK\r\n";
static const uint8_t xmemfail[] PROGMEM="XMEM FAIL!\r\n";
static const uint8_t heapfull[] PROGMEM="Heap Full\r\n";
static const uint8_t heaprdfail[] PROGMEM="Heap Test Fail\r\n";
static const uint8_t heaprdok[] PROGMEM="Heap Test OK\r\n";
portSHORT *xmem;
portSHORT xdata;
unsigned portSHORT index, testflag=0;
portTickType xLastWakeTime;
const portTickType xFrequency = 10000;
	xmem = malloc(BUFFER_SIZE);
xLastWakeTime=xTaskGetTickCount();
	if (xmem!=NULL)
	{
		xUSART0SendDataP(xmemok);
	}
	else 
	{
		xUSART0SendDataP(xmemfail);
	}
	for (;;)
	{
		xdata=1;
		for(index = 0; index < BUFFER_SIZE; index++)
			{
    			xmem[index] = xdata++;
			}
		xUSART0SendDataP(heapfull);
		//read heap and test
		xdata=1;
		for(index = 0; index < BUFFER_SIZE; index++)
		{
			if (xmem[index] != xdata++)
			{
				testflag=1;
				break;
			}
		}
		if (!testflag)
		{
			xUSART0SendDataP(heaprdok);
		}
		else
		{
			//reset flag
			testflag=0;
			xUSART0SendDataP(heaprdfail);
		}
		vTaskDelayUntil(&xLastWakeTime,xFrequency);	
	}
}
